package com.fractalite.hermes.teldar.Marshaller;

import java.io.ByteArrayInputStream;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.Unmarshaller;
import javax.xml.soap.MessageFactory;
import javax.xml.soap.SOAPMessage;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Component;
import com.gekko_holding.webservice.v2_4.BookHotelResponse;
import com.gekko_holding.webservice.v2_4.CancelBookingSegmentResponse;
import com.gekko_holding.webservice.v2_4.GetHotelDetailsResponse;
import com.gekko_holding.webservice.v2_4.GetPreBookingInfoResponse;
import com.gekko_holding.webservice.v2_4.HotelAvailabilityResponse;;

@Component
public class UnmarshallingJAXB {

	private static final Logger logger = LoggerFactory.getLogger(UnmarshallingJAXB.class);

	public static <T> T printObject(Class<T> objectClass, String xml) {

		T rslt = null;
		SOAPMessage message = null;
		JAXBContext jaxbContext = null;
		Unmarshaller unmarshaller = null;

		try {
			message = MessageFactory.newInstance().createMessage(null, new ByteArrayInputStream(xml.getBytes()));
			jaxbContext = JAXBContext.newInstance(objectClass);
			unmarshaller = jaxbContext.createUnmarshaller();
			if (message.getSOAPBody().getFirstChild().getLocalName().toLowerCase()
					.equals(objectClass.getSimpleName().toLowerCase())) {
				rslt = (T) unmarshaller.unmarshal(message.getSOAPBody().extractContentAsDocument());
			} else {
				logger.error("Error in printObject function to set result");
//				throw new RuntimeException();
			}
			return rslt;
		} catch (Exception exception) {
			logger.error("Exception in printObject function" + exception.getMessage());
		}
		return null;
	}

	/* Availability Response Unmashaller. */
	public static HotelAvailabilityResponse fromHotelAvailabilityResponse(String exchangeBody) {
		HotelAvailabilityResponse unmarshalledObject = printObject(HotelAvailabilityResponse.class, exchangeBody);
		return unmarshalledObject;
	}

	public static GetHotelDetailsResponse fromGetDetailsResponse(String exchangeBody) {
		GetHotelDetailsResponse unmarshalledObject = printObject(GetHotelDetailsResponse.class, exchangeBody);
		return unmarshalledObject;

	}

	public static GetPreBookingInfoResponse fromPreBookingInfoResponse(String exchangeBody) {
		GetPreBookingInfoResponse unmarshalledObject = printObject(GetPreBookingInfoResponse.class, exchangeBody);
		return unmarshalledObject;
	}

	public static BookHotelResponse fromBookHotelResponse(String exchangeBody) {
		BookHotelResponse unmarshalledObject = printObject(BookHotelResponse.class, exchangeBody);
		return unmarshalledObject;

	}

	  public static CancelBookingSegmentResponse fromBookingCancellation(String exchangeBody) {
	    	CancelBookingSegmentResponse unmarshalledObject=printObject(CancelBookingSegmentResponse.class, exchangeBody);
	    	return unmarshalledObject;
	    	
	    }
}
