package com.fractalite.hermes.teldar.parsers;

import java.io.IOException;
import java.text.ParseException;

import javax.xml.parsers.ParserConfigurationException;
import javax.xml.xpath.XPathExpressionException;

import org.apache.camel.Exchange;
import org.apache.camel.InvalidPayloadException;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.xml.sax.SAXException;

import com.fractalite.hermes.teldar.tools.ObjectToXml;
import com.fractalite.models.commerce.Order;
import com.fractalite.models.commerce.OrderStatus;
import com.fractalite.models.commerce.TermOfSale;
import com.fractalite.models.travel.stay.StayItem2;
import com.gekko_holding.webservice.v2_4.BookHotelResponse;
import com.gekko_holding.webservice.v2_4.BookResponse;
import com.gekko_holding.webservice.v2_4.Segment;

public class ParseConfirmBookResponse extends TeldarParsers {

	protected static Logger logger = LoggerFactory.getLogger(ParseConfirmBookResponse.class);

	@Override
	public void process(Exchange exchange) throws InvalidPayloadException, ParserConfigurationException, SAXException,
			IOException, XPathExpressionException, ParseException {

		logger.info("Invoking TELDAR ParseBookHotelResponsee Processor.......");
		Order oldOrder = exchange.getProperty("order", Order.class);
		String custoNumber = exchange.getProperty("custoNumber", String.class);
		BookHotelResponse respbookhotel = exchange.getIn().getBody(BookHotelResponse.class);
		Order order = printHotelInfo(respbookhotel.getBookResponse(), oldOrder, custoNumber);
		logger.info("new oneeeesss " + ObjectToXml.printXML(order));
		exchange.getIn().setBody(order);
		logger.info("End TELDAR ParseBookHotelResponse Processor.......");
	}

	private Order printHotelInfo(BookResponse bookHotels, Order order, String custoNumber) {

		if (bookHotels != null && bookHotels.getBookingId() != null) {

			logger.info(" \n bookHotels" + bookHotels + "̣ size " + bookHotels.getBookingId());
			order.setNumber(bookHotels.getBookingId());

			for (Segment respSegment : bookHotels.getSegments().getSegment()) {

				order.setStatus(OrderStatus.CONFIRMED);

				TermOfSale termsOfSalePayable = new TermOfSale();
				termsOfSalePayable.setCode("PAYEDBY");
				termsOfSalePayable.setDescription("  Teldar Hotels Group " + respSegment.getSupplierBookingNumber());
				order.getPricing().getItems(StayItem2.class).get(0).getProduct().getTermsOfSales()
						.add(termsOfSalePayable);
				for (StayItem2 lineItem : order.getPricing().getItems(StayItem2.class)) {

					lineItem.setStatus(OrderStatus.CONFIRMED);
					lineItem.setReference(bookHotels.getBookingId());
				}
				// SupplierBookingNumber

				if (respSegment.getSupplierBookingNumber() != null) {
					order.setNumber(bookHotels.getBookingId() + "_" + respSegment.getSupplierBookingNumber() + "_"
							+ custoNumber);

					logger.info("seggggggg " + respSegment.getSupplierBookingNumber());
					logger.info("seggggId " + bookHotels.getBookingId());
				}

			}
		}

		return order;

	}
}
